#ifndef _HTTPD_H_
#define _HTTPD_H_

enum {
	HTTPD_METHOD_UNKNOWN = 0, HTTPD_METHOD_GET , HTTPD_METHOD_POST
};

struct httpd_session_data;

// 
//   1.athenahttpd ő傫ȃt@C𑗐M邱Ƃ͂߂܂B
//     200KB 𒴂悤ȃt@ĆAʂ̃\tg𗘗p邱Ƃ߂܂B
//   2.t@CɎg镶́A[A-Za-z0-9-_\.] łB̕gƁA
//     BAD REQUEST Œe܂B


void httpd_pages(const char* url,void(*httpd_func)(struct httpd_session_data* sd,const char* url));

// w肳ꂽURL ɑ΂R[obN֐ݒ肷B̊֐́Aȉ̂悤
// KvB
//
// 1. URL ́A擪̃XbVȂꂽt@CłBႦ΁A"GET / HTTP/1.0"
//    ƂɃNGXgꂽAURL ɂ""(󕶎)A"GET /hoge HTTP/1.0"
//    ̎ɂ́A"hoge"܂B
// 2. NGXgꂽy[WAhttpd_send() ܂́Ahttpd_send_head()
//    httpd_send_data() ̑gĂяoAf[^o͂B
// 3. httpd_send_file w肷ƁAhttpd/ ȉɂt@Co͂Bt@C
//    󕶎w肳ꂽ́Aindex.htmlw肳ꂽ̂Ƃ݂ȂB



char* httpd_get_value(struct httpd_session_data* sd,const char* val);

// NGXgꂽAhXɓnꂽtH[f[^̂AY镶ԂB
// Ⴆ΁A"GET /status/graph?image=users HTTP/1.0"ƂNGXg̏ꍇA
// httpd_get_value(sd,"image"); ́A "users"ԂB̊֐̖߂ĺAĂяo
// Ȃ΂ȂȂB܂AY镶񂪖́A̕ԂB

int httpd_get_method(struct httpd_session_data* sd);

// NGXg`ԂB
// 
//     GET  : HTTPD_METHOD_GET
//     POST : HTTPD_METHOD_POST

unsigned int httpd_get_ip(struct httpd_session_data *sd);

// NCAgIPԂB


void httpd_default_page(void(*httpd_func)(struct httpd_session_data* sd,const char* url));

// w肳ꂽURL o^ĂȂɌĂяo֐ݒ肷B̊֐ĂяoȂA
// ֐̈NULLw肷ƁA404 Not Found ԂB




void httpd_send(struct httpd_session_data* sd,int status,const char *content_type,int content_len,const void *data);

//	HTTPwb_Af[^gɂđMB̊֐ĂяoɁAhttpd_send_data 
//  ĂяoĂ͂ȂȂB
// 
//		sd           : httpd_set_parse_func() ɓnꂽ̂̂܂ܓnƁB
//		status       : HTTPwb_ɉstatusBʏ200B
//		content_type : Mf[^̃^CvBtext/html , image/jpeg ȂǁB
//		content_len  : Mf[^̒B
//		data         : Mf[^ւ̃|C^



void httpd_send_head(struct httpd_session_data* sd,int status,const char *content_type,int content_len);

//	HTTPwb_𑗐MB
//
//		sd           : 
//		status       : 
//		content_type : 
//      content_len  : content_len-1Ɏw肷邱ƂŁÅ֐Ă΂ꂽ_
//                     Ȃf[^𑗐M邱ƂłB̏ꍇ
//                     IHTTP/1.0 ڑƂȂAI[o[wbh傫Ȃ̂ŁA
//                     ܂肨߂͂ȂB




void httpd_send_data(struct httpd_session_data* sd,int content_len,const void *data);

// f[^𑗐MB̊֐Ahttpd_send_head() ĂяoOɌĂяoꂽꍇA
// content_type = application/octet-stream, content_len = -1 Ƃăwb_MB
//		sd           : 
//      content_len  : Mf[^dataw肷B
//      data         : Mf[^



void httpd_send_file(struct httpd_session_data* sd,const char* url);

// t@C𑗐MB̊֐́Ahttpd_send_head() ĂяoOɌĂяoȂ
// ȂȂBt@Cɋ󕶎w肳ꂽƂ́Aindex.htmlw肳ꂽƌȂB



void httpd_send_error(struct httpd_session_data* sd,int status);

// HTTPG[bZ[W𑗐MBstatus HTTP̃G[R[hƓB
// 	400 Bad Request, 404 Not Found, 500 Internal Server Error ȂǁB

int  httpd_parse(int fd);

// 
void do_init_httpd(void);

// hLg[gݒ
void httpd_set_document_root( const char *str );

// ^CAEgԐݒ
void httpd_set_request_timeout( int idx, int time );

// ʐMł̃NGXgő吔ݒ
void httpd_set_max_persist_requests( int count );

// Ot@Cݒ
void httpd_set_logfile( const char *str );

// ݒt@Cǂݍ
int httpd_config_read(char *cfgName);


// ^( < , > , & , " ) GXP[vԂB
// XSS (NXTCgXNveBO)ɑΏ邽߁A[U[͂
// ̂܂܏o͂鎞́Å֐ʂăGXP[vo
// ׂłB̊֐̖߂ĺAĂяoȂ΂ȂȂB
char* httpd_quote_meta(const char* p1);

// ^ꂽ %xx ̌`ɃGR[hԂB
// URL ̒ɓ{ꂪUFT-8đMuEÛŁA
// }`oCg <a href=""> ̒ɓ鎞ɎgpĂB
// ̊֐̖߂ĺAĂяoȂ΂ȂȂB
char* httpd_binary_encode(const char* val);

// base64 fR[hB
// dest ɂ͏\ȃTCY( [src ̒] / 4 * 3 )́Amۂ
// KvB  1, s 0 Ԃ
int httpd_decode_base64( char *dest, const char *src);

#endif
